/*
overlaycoloring.glsl
fragment shader

performs overlay blending between texture and vertex
*/

// Texture to render
uniform sampler2D ColorTexture;

void shader(){
	// take fragment color and undo pre-multiplication
	vec4 frag = texture2D( ColorTexture, b3d_Texcoord0 );
	frag.rgb /= frag.a;
	// take vertex color and undo pre-multiplication
	vec4 vert = b3d_Color;
	vert.rgb /= b3d_Color.a;
	
	float alpha = frag.a * vert.a;
	
	// do the overlay magic
	b3d_FragColor = vec4(clamp(frag.rgb + vert.rgb - 0.5, 0.0, 1.0) * alpha, alpha);
}
